//----------------------------------------------------------------------//
// NyanFi																//
//  t@C/ڂ̏Wv												//
//----------------------------------------------------------------------//
#include "UserFunc.h"
#include "Global.h"
#include "MainFrm.h"
#include "SubView.h"
#include "FileInfDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFileInfoDlg *FileInfoDlg;

//---------------------------------------------------------------------------
__fastcall TFileInfoDlg::TFileInfoDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::FormCreate(TObject *Sender)
{
	DlgInitialized = false;

	FileRec   = NULL;
	isAppInfo = isGitInfo = isCalcItem = false;
	inhNxtPre = inhImgPrv = useImgPrv = false;

	CsvCol	 = -1;
	DataList = NULL;
	ItemList = new TStringList();

	ListScrPanel = new UsrScrollPanel(ListPanel, InfListBox, USCRPNL_FLAG_P_WP | USCRPNL_FLAG_L_WP);
	InfListBox->Tag = LBTAG_FIF_LIST | LBTAG_OPT_FIF2 | LBTAG_OPT_ZOOM;
}
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::FormShow(TObject *Sender)
{
	DlgInitialized = false;

	CmdStr = EmptyStr;
	useImgPrv = !inhImgPrv && !isCalcItem && !isAppInfo && !isGitInfo;

	JumpFileName = EmptyStr;

	if (isCalcItem)
		IniFile->LoadPosInfo(this, DialogCenter, "CalcItem");
	else
		IniFile->LoadPosInfo(this, DialogCenter);

	if (!isAppInfo && !isGitInfo) InfListBox->Clear();

	set_ListBoxItemHi(InfListBox, FileInfFont);
	set_UsrScrPanel(ListScrPanel);
	InfListBox->Color = get_InfBgCol();

	if (!UpdateInfo()) ::PostMessage(Handle, WM_CLOSE, 0, 0);

	ImgPreviewAction->Checked = useImgPrv? IniFile->ReadBoolGen(_T("FileInfoImgPrv")) : false;
	if (ImgPreviewAction->Checked) {
		if (!SubViewer->Visible) {
			SubViewer->formFileInf = true;
			SubViewer->Show();
		}
		if (FileRec) SubViewer->DrawImage(FileRec->f_name);
		SetFocus();
	}

	DlgInitialized = true;
}
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	if (isCalcItem) {
		IniFile->SavePosInfo(this, "CalcItem");
	}
	else {
		IniFile->SavePosInfo(this);
		if (useImgPrv) IniFile->WriteBoolGen(_T("FileInfoImgPrv"), ImgPreviewAction);
		if (SubViewer->Visible) SubViewer->Close();
	}

	FileRec    = NULL;
	isAppInfo  = isGitInfo = false;
	isCalcItem = inhNxtPre = inhImgPrv = useImgPrv = false;
	CsvCol	   = -1;
	DataList   = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::FormDestroy(TObject *Sender)
{
	delete ItemList;
	delete ListScrPanel;
}

//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::FormResize(TObject *Sender)
{
	if (isCalcItem) InfListBox->Invalidate();
}

//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if (isCalcItem)
		SpecialKeyProc(this, Key, Shift, _T(HELPTOPIC_TV) _T("#CsvCalc"));
	else
		SpecialKeyProc(this, Key, Shift, _T(HELPTOPIC_FL) _T("#ShowFileInfo"));
}
//---------------------------------------------------------------------------
//wt@C̏\ (Oړ֎~)
//---------------------------------------------------------------------------
int __fastcall TFileInfoDlg::ShowModalEx(UnicodeString fnam)
{
	int res = mrNone;
	if (file_exists(fnam)) {
		file_rec *cfp = cre_new_file_rec(fnam);
		FileRec   = cfp;
		inhImgPrv = !test_FileExt(cfp->f_ext, FEXT_IMAGE + get_img_fext() + ".mp3.flac" + FEXT_INDIVICO);
		inhNxtPre = true;
		res = ShowModal();
		del_file_rec(cfp);
	}

	return res;
}

//---------------------------------------------------------------------------
//ꗗ̍XV
//---------------------------------------------------------------------------
int __fastcall comp_ObjLD(TStringList *List, int Index1, int Index2)
{
	long double *v0 = (long double*)List->Objects[Index1];
	long double *v1 = (long double*)List->Objects[Index2];
	if (!v0 || !v1)	return 0;

	if (*v0==*v1)	return 0;
	return (*v0 > *v1)? 1 : -1;
}
//---------------------------------------------------------------------------
bool __fastcall TFileInfoDlg::UpdateInfo()
{
	TListBox *lp = InfListBox;

	if (isAppInfo) {
		set_FormTitle(this, _T("AvP[V"));
		assign_InfListBox(lp, ItemList, ListScrPanel);
		return true;
	}

	if (isGitInfo) {
		set_FormTitle(this, _T("R~bg"));
		assign_InfListBox(lp, ItemList, ListScrPanel);
		return true;
	}

	//ڂ̏Wv
	if (isCalcItem) {
		try {
			if (!DataList) Abort();
			UnicodeString top_str = DataList->Strings[0];
			bool IsCSV = !ContainsStr(top_str, "\t");
			set_FormTitle(this, IsCSV? _T("CSVڂ̏Wv") : _T("TSVڂ̏Wv"));
			TStringDynArray top_buf = IsCSV? get_csv_array(top_str, 99) : split_strings_tab(top_str);
			if (CsvCol==-1) CsvCol = 0;
			if (CsvCol>=top_buf.Length) Abort();

			//ږ
			UnicodeString i_nam;
			if (TopIsHeader)
				i_nam = IsCSV? get_csv_item(top_str, CsvCol) : get_tsv_item(top_str, CsvCol);
			else
				i_nam.sprintf(_T("%u"), CsvCol + 1);

			long double total = 0.0;
			long double i_max = 0, i_min = 0;
			int f_w = 0;	//̕\
			std::unique_ptr<TStringList> s_lst(new TStringList());	//LȐlڂ̃Xg
			for (int i=(TopIsHeader? 1 : 0); i<DataList->Count; i++) {
				UnicodeString lbuf = DataList->Strings[i];
				UnicodeString istr = extract_top_num_str(IsCSV? get_csv_item(lbuf, CsvCol) : get_tsv_item(lbuf, CsvCol));
				if (istr.IsEmpty()) continue;
				try {
					long double r = istr.ToDouble();
					total += r;
					if (s_lst->Count==0) {
						i_min = i_max = r;
					}
					else {
						i_min = std::min(i_min, r);
						i_max = std::max(i_max, r);
					}

					long double *dp = new long double;
					*dp = r;
					s_lst->AddObject(istr, (TObject*)dp);

					int p = istr.Pos('.');
					if (p) f_w = std::max(f_w, istr.Length() - p);
				}
				catch (...) {
					;
				}
			}

			int i_cnt = s_lst->Count;
			if (i_cnt==0) Abort();

			//ϒl
			long double i_ave = total/i_cnt;
			//l
			s_lst->CustomSort(comp_ObjLD);
			long double i_med = (i_cnt%2==1)?
		 		*(long double*)s_lst->Objects[(i_cnt - 1) / 2] :
				(*(long double*)s_lst->Objects[i_cnt/2 - 1] + *(long double*)s_lst->Objects[i_cnt/2]) /2;
			//U
			long double sum = 0;
			for (int i=0; i<s_lst->Count; i++) {
				long double v = *(long double*)s_lst->Objects[i];
				sum += (v - i_ave) * (v - i_ave);
			}
			long double i_var = sum/i_cnt;
			//W΍
			long double i_std = sqrtl(i_var);

			//K(X^[WFX̌)
			int k = 1 + (int)(log10l(i_cnt)/log10l(2) + 0.5);
			//K
			long double d = (i_max - i_min)/k;
			//xz
			std::unique_ptr<int[]> freq(new int[k]);
			std::unique_ptr<TStringList> f_lst(new TStringList());
			for (int i = 0; i < k; i++) freq[i] = 0;
			for (int i=0; i<i_cnt; i++) {
				long double v = *(long double*)s_lst->Objects[i];
				for (int j=0; j<k; j++) {
					long double lmt = i_min + d * (j + 1);
					if (f_w==0) lmt = floorl(lmt + 0.5);
					if ((j==(k - 1) && v <=i_max) || (v < lmt)) {
						freq[j]++;	break;
					}
				}
			}

			MaxColWd0 = MaxColWd1 = MaxColWd2 = 0;

			TCanvas *cv = lp->Canvas;
			cv->Font->Assign(lp->Font);

			Max_freq = 0;
			for (int i=0; i<k; i++) Max_freq = std::max(Max_freq, freq[i]);
			if (Max_freq>0) {
				int f_sum = 0;
				for (int i=0; i<k; i++) {
					UnicodeString s0, s1, s2;
					//Kl
					long double lmt = i_min + d * i;
					if (f_w==0) lmt = floorl(lmt + 0.5);
					s0.sprintf(_T("%s`"), ldouble_to_str(lmt, f_w).c_str());
					//x
					s1 = IntToStr(freq[i]);
					f_sum += freq[i];
					//ݐϑΓx
					s2.sprintf(_T("%.3f"), 1.0*f_sum/i_cnt);
					f_lst->Add(s0 + "\t" + s1 + "\t" + s2);
					MaxColWd0 = std::max(MaxColWd0, cv->TextWidth(s0));
					MaxColWd1 = std::max(MaxColWd1, cv->TextWidth(s1));
					MaxColWd2 = std::max(MaxColWd2, cv->TextWidth(s2));
				}
			}

			//l̉
			for (int i=0; i<s_lst->Count; i++) delete (long double*)s_lst->Objects[i];

			//ʕ\
			std::unique_ptr<TStringList> i_lst(new TStringList());
			UnicodeString tmp;
			FreqIndex = 0;
			add_PropLine(_T("ږ"),		i_nam,	i_lst.get());
			i_lst->Add(EmptyStr);
			add_PropLine(_T("Lڐ"),	i_cnt,	i_lst.get());
			add_PropLine(_T("vl"),		ldouble_to_str(total, f_w),	i_lst.get());
			add_PropLine(_T("ŏl"),		ldouble_to_str(i_min, f_w),	i_lst.get());
			add_PropLine(_T("ől"),		ldouble_to_str(i_max, f_w),	i_lst.get());
			i_lst->Add(EmptyStr);
			add_PropLine(_T("ϒl"),		ldouble_to_str(i_ave, f_w + 1),	i_lst.get());
			add_PropLine(_T("l"),		ldouble_to_str(i_med, f_w),		i_lst.get());
			add_PropLine(_T("U"),		ldouble_to_str(i_var, f_w + 1),	i_lst.get());
			add_PropLine(_T("W΍"),	ldouble_to_str(i_std, f_w + 1),	i_lst.get());
			if (f_lst->Count>0) {
				i_lst->Add(EmptyStr);
				FreqIndex = i_lst->Add(_T("xz"));
				i_lst->AddStrings(f_lst.get());
			}
			assign_InfListBox(lp, i_lst.get(), ListScrPanel);
			return true;
		}
		catch (...) {
			msgbox_ERR("LȐlڂ܂");
			return false;
		}
	}

	//t@C
	if (!FileRec) FileRec = NyanFiForm->GetCurFrecPtr(false, true);
	if (FileRec) {
		cursor_HourGlass();

		Caption = UnicodeString().sprintf(_T("%s ̏"), (FileRec->is_up? FileRec->p_name : FileRec->n_name).c_str());

		if (!FileRec->is_dir && FileRec->is_virtual && !FileRec->failed) FileRec->failed = !SetTmpFile(FileRec);
		if (!FileRec->is_dummy && FileRec->inf_list->Count==0) GetFileInfList(FileRec, true);

		std::unique_ptr<TStringList> i_lst(new TStringList());
		i_lst->Assign(FileRec->inf_list);

		if (i_lst->Count>=3) {
			int idx = 0;
			if (!FileRec->is_up) {
				i_lst->Strings[idx] = make_PropLine(FileRec->is_dir? _T("fBNg") : _T("t@C"), i_lst->Strings[idx]);
				i_lst->Objects[idx] = (TObject*)LBFLG_FILE_FIF;
				idx++;
				i_lst->Strings[idx] = make_PropLine(_T("ꏊ"), i_lst->Strings[idx]);
				i_lst->Objects[idx] = (TObject*)LBFLG_PATH_FIF;
			}
			else {
				i_lst->Delete(0);
				i_lst->Strings[idx] = make_PropLine(_T("fBNg"), i_lst->Strings[idx]);
				i_lst->Objects[idx] = (TObject*)LBFLG_FILE_FIF;
			}
			idx++;
			i_lst->Strings[idx] = make_PropLine(FileRec->is_ftp? "p[~bV" : "", FileRec->attr_str);
			i_lst->Objects[idx] = (TObject*)LBFLG_ATTR_FIF;
			idx++;

			//t@CTCY
			if (!FileRec->is_dir) {
				//TCY
				if (FileRec->f_size>=0) {
					i_lst->Insert(idx++,
						get_PropTitle(_T("TCY")).cat_sprintf(_T("%s (%s)"),
							get_size_str_G(FileRec->f_size, 10, SizeDecDigits, 1).c_str(),
							get_size_str_B(FileRec->f_size, 5).c_str()));
				}
				//LTCY
				if (!FileRec->is_virtual && !FileRec->is_ftp) {
					int clu_sz = get_ClusterSize(FileRec->p_name);	//NX^TCY
					if (clu_sz>0) {
						__int64 o_size;
						if (FileRec->is_dir)
							o_size = FileRec->o_size;
						else {
							__int64 clu_n = FileRec->f_size/clu_sz;
							if (FileRec->f_size%clu_sz>0) clu_n++;
							o_size = (clu_n * clu_sz);
						}
						if (o_size>=0) {
							i_lst->Insert(idx++,
								get_PropTitle(_T("LTCY")).cat_sprintf(_T("%s (%s)"),
									get_size_str_G(o_size, 10, SizeDecDigits, 1).c_str(),
									get_size_str_B(o_size, 5).c_str()));
						}
					}
				}
			}

			//
			i_lst->InsertObject(idx++,
				make_PropLine(_T("XV"), format_DateTime(FileRec->f_time)), (TObject*)LBFLG_TIME_FIF);

			if (!FileRec->is_virtual && !FileRec->is_ftp) {
				HANDLE hFile = ::CreateFile(cv_ex_filename(FileRec->f_name).c_str(),
					GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
				if (hFile!=INVALID_HANDLE_VALUE) {
					FILETIME c_tm, a_tm, w_tm, f_tm;
					if (::GetFileTime(hFile, &c_tm, &a_tm, &w_tm)) {
						i_lst->InsertObject(idx++,
							make_PropLine(_T("쐬"), format_DateTime(utc_to_DateTime(&c_tm))),
							(TObject*)LBFLG_TIME_FIF);
						i_lst->InsertObject(idx++,
							make_PropLine(_T("ANZX"), format_DateTime(utc_to_DateTime(&a_tm))),
							(TObject*)LBFLG_TIME_FIF);
					}
					::CloseHandle(hFile);
				}
			}
			i_lst->Insert(idx, EmptyStr);
		}
		assign_InfListBox(lp, i_lst.get());
		cursor_Default();
	}
	else {
		set_FormTitle(this, _T("t@C"));
	}

	ListScrPanel->UpdateKnob();
	return true;
}

//---------------------------------------------------------------------------
//ꗗ̕`
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::InfListBoxDrawItem(TWinControl *Control, int Index,
		TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;

	//xz
	if (isCalcItem && FreqIndex>0 && Index>=FreqIndex) {
		TCanvas *cv = lp->Canvas;
		cv->Font->Assign(lp->Font);

		cv->Brush->Color = (State.Contains(odSelected) && lp->Focused())? col_selItem : get_InfBgCol();
		cv->FillRect(Rect);

		int xp = Rect.Left + SCALED_THIS(8);
		int yp = Rect.Top  + SCALED_THIS(1);
		bool use_fgsel = lp->Focused() && is_SelFgCol(State);

		TStringDynArray itm_buf = split_strings_tab(lp->Items->Strings[Index]);
		if (itm_buf.Length==1) {
			cv->Font->Color = use_fgsel? col_fgSelItem : col_fgInfNam;
			cv->TextOut(xp, yp, itm_buf[0]);
		}
		else if (itm_buf.Length==3) {
			//K
			cv->Font->Color = use_fgsel? col_fgSelItem : get_InfFgCol();
			cv->TextOut(xp + MaxColWd0 - cv->TextWidth(itm_buf[0]), yp, itm_buf[0]);
			xp += MaxColWd0 + SCALED_THIS(8);
			//؂
			cv->Pen->Style = psSolid;
			cv->Pen->Width = 1;
			cv->Pen->Color = col_HR;
			cv->MoveTo(xp, Rect.Top);  cv->LineTo(xp, Rect.Bottom);
			//x
			xp += SCALED_THIS(8);
			int n = itm_buf[1].ToIntDef(0);
			cv->TextOut(xp + MaxColWd1 - cv->TextWidth(itm_buf[1]), yp, itm_buf[1]);
			xp += MaxColWd1 + SCALED_THIS(4);
			cv->MoveTo(xp, Rect.Top);  cv->LineTo(xp, Rect.Bottom);
			//ݐϑΓx
			xp += SCALED_THIS(8);
			cv->TextOut(xp + MaxColWd2 - cv->TextWidth(itm_buf[2]), yp, itm_buf[2]);
			xp += MaxColWd2 + SCALED_THIS(4);

			//Ot
			TRect rc = Rect;
			rc.Left  = xp;
			if (ScrBarStyle>0) {
				rc.Right = ListPanel->ClientWidth;
				if (ListScrPanel->VisibleV) rc.Right -= ListScrPanel->KnobWidth;
			}
			rc.Right -= SCALED_THIS(2);
			cv->Brush->Color = col_bgPrgBar;
			cv->FillRect(rc);
			if (Max_freq>0) {
				rc.Right = rc.Left + rc.Width() * (0.9 * n / Max_freq);
				cv->Brush->Color = col_fgPrgBar;
				cv->FillRect(rc);
				cv->Brush->Color = TStyleManager::ActiveStyle->GetSystemColor(clWindowText);
				cv->FrameRect(rc);
			}
		}
	}
	//
	else {
		draw_InfListBox(lp, Rect, Index, State);
	}

	draw_ListCursor2(lp, Rect, Index, State);
}

//---------------------------------------------------------------------------
//L[
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::InfListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	UnicodeString KeyStr = get_KeyStr(Key, Shift);
	UnicodeString cmd_F  = Key_to_CmdF(KeyStr);
	UnicodeString cmd_V  = Key_to_CmdV(KeyStr);
	TListBox *lp = (TListBox*)Sender;

	bool handled = true;
	if (ExeCmdListBox(lp, cmd_F) || ExeCmdListBox(lp, cmd_V)) {
		;
	}
	//Õt@C֐؂ւ
	else if (FileRec && !FileRec->is_ftp && !inhNxtPre && contained_wd_i("PrevFile|NextFile", cmd_V)) {
		CmdStr = cmd_V;
		//ʂɎc
		this->Perform(WM_SETREDRAW, 0, (NativeInt)0);
		if (SubViewer->Visible) SubViewer->Perform(WM_SETREDRAW, 0, (NativeInt)0);
		ModalResult = mrRetry;
	}
	else if (SameText(cmd_F, "PropertyDlg")) {
		PropertyDlgAction->Execute();
	}
	else if (SameText(cmd_F, "ShowPreview") || SameText(cmd_V, "ImgPreview")) {
		ImgPreviewAction->Execute();
	}
	else if (SameText(KeyStr, KeyStr_Copy)) {
		CopyAction->Execute();
	}
	else if (contained_wd_i(KeysStr_Popup, KeyStr)) {
		show_PopupMenu(lp);
	}
	else if	(equal_ESC(KeyStr)) {
		ModalResult = mrOk;
	}
	else handled = false;

	if (handled) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::InfListBoxKeyPress(TObject *Sender, System::WideChar &Key)
{
	//CN^T[`
	if (_istalnum(Key) || Key==VK_SPACE) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::InfListBoxDblClick(TObject *Sender)
{
	OpenLocAction->Execute();
}

//---------------------------------------------------------------------------
//t@CRs[
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::CopyInfoActionExecute(TObject *Sender)
{
	copy_to_Clipboard(InfListBox->Items->Text);
}
//---------------------------------------------------------------------------
//ڂ̒lRs[
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::CopyValueActionExecute(TObject *Sender)
{
	copy_to_Clipboard(Trim(get_tkn_r(ListBoxGetStr(InfListBox), ": ")));
}

//---------------------------------------------------------------------------
//̍ړe\
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::EmpItemActionExecute(TObject *Sender)
{
	UnicodeString inam = Trim(get_tkn(ListBoxGetStr(InfListBox), ':'));
	if (!inam.IsEmpty()) {
		std::unique_ptr<TStringList> n_lst(new TStringList());
		n_lst->Delimiter = '|';
		n_lst->QuoteChar = '\0';
		n_lst->DelimitedText = EmpInfItems;
		int idx = n_lst->IndexOf(inam);
		if (idx!=-1) n_lst->Delete(idx); else n_lst->Add(inam);
		EmpInfItems = n_lst->DelimitedText;
		InfListBox->Invalidate();
	}
}
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::EmpItemActionUpdate(TObject *Sender)
{
	TAction *ap  = (TAction *)Sender;
	int flag = (int)ListBoxGetObj(InfListBox);
	UnicodeString inam = ((flag & LBFLG_STD_FINF)==0)? Trim(get_tkn(ListBoxGetStr(InfListBox), ':')) : EmptyStr;
	ap->Enabled = !inam.IsEmpty();
	ap->Checked = test_word_i(inam, EmpInfItems);
}

//---------------------------------------------------------------------------
//Rs[
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::CopyActionExecute(TObject *Sender)
{
	ExeCmdListBox(InfListBox, "ClipCopy");
}
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::CopyActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = (Active && InfListBox->SelCount>0);
}
//---------------------------------------------------------------------------
//ׂđI
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::SelAllActionExecute(TObject *Sender)
{
	ListBoxSelectAll(InfListBox);
}
//---------------------------------------------------------------------------
//URL/ꏊJ
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::OpenLocActionExecute(TObject *Sender)
{
	if (Active && !ListBoxGetURL(InfListBox).IsEmpty()) {
		Execute_ex(ListBoxGetURL(InfListBox));
	}
	else if (ScrMode==SCMD_FLIST && !isAppInfo && !isGitInfo && !isCalcItem) {
		JumpFileName = InfListBoxGetDir(InfListBox);
		ModalResult  = mrOk;
	}
}
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::OpenLocActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction*)Sender;
	if (Active && !ListBoxGetURL(InfListBox).IsEmpty()) {
		ap->Caption = "URLJ(&W)";
		ap->Visible = true;
	}
	else if (ScrMode==SCMD_FLIST && !isAppInfo && !isGitInfo && !isCalcItem && !InfListBoxGetDir(InfListBox).IsEmpty()) {
		ap->Caption = "ꏊJ(&L)";
		ap->Visible = true;
	}
	else {
		ap->Visible = false;
	}

	ap->Enabled = ap->Visible;
}

//---------------------------------------------------------------------------
//vpeB
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::PropertyDlgActionExecute(TObject *Sender)
{
	ShowPropertyDialog(FileRec->f_name);
}
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::PropertyDlgActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = (FileRec && !FileRec->is_virtual);
}
//---------------------------------------------------------------------------
//C[Wvr[
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::ImgPreviewActionExecute(TObject *Sender)
{
	TAction *ap = (TAction*)Sender;
	ap->Checked = !ap->Checked;

	if (ap->Checked) {
		if (!SubViewer->Visible) {
			SubViewer->formFileInf = true;
			SubViewer->Show();
		}
		if (FileRec) SubViewer->DrawImage(FileRec->f_name);
	}
	else {
		if (SubViewer->Visible) SubViewer->Close();
	}

	SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TFileInfoDlg::ImgPreviewActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction*)Sender;
	ap->Visible = useImgPrv;
	ap->Enabled = ap->Visible && FileRec;
	ap->Checked = ap->Enabled && SubViewer->Visible;
}
//---------------------------------------------------------------------------
