/**
 * @file usr_highlight.h
 * @brief \\
 */
//---------------------------------------------------------------------------
#ifndef UsrHighlightH
#define UsrHighlightH

//---------------------------------------------------------------------------
#include "UIniFile.h"

//---------------------------------------------------------------------------
/**
 * @brief \\`t@C
 */
class HighlightFile : public UsrIniFile
{
private:
	TDateTime HighlightTime;	//݂̃^CX^v

	void CheckValues();

public:
	UnicodeString CurSection;	//!< gp̃ZNV
	TStringList   *ErrorList;

	HighlightFile(UnicodeString fnam);
	~HighlightFile();

	UnicodeString ReadKeyStr(const _TCHAR *key);
	int			  ReadKeyInt(const _TCHAR *key, int def = 0);
	bool		  ReadKeyBool(const _TCHAR *key, bool def = false);
	UnicodeString ReadRegExPtn(const _TCHAR *key);
	TColor		  ReadColorRGB6H(const _TCHAR *key, TColor def = clBlack);

	/** @brief ^CX^vωĂēǂݍ */
	bool Recycle();

	/**
	 * @brief \\`t@CΉZNV擾
	 * @param fnam t@C
	 * @param is_clip Nbv{[h
	 * @param is_log ^XNO
	 * @param is_h2t HTMLTEXTϊ[h
	 * @return true ZNV擾
	 */
	bool GetSection(UnicodeString fnam,
			bool is_clip = false, bool is_log = false, bool is_h2t = false);

	/**
	 * @brief Rgʕ擾
	 * @param fnam t@C
	 * @param ln_lst PsRg
	 * @param bgn_lst ubNJn
	 * @param end_lst ubNI
	 * @param is_h2t HTMLTEXTϊ[h
	 * @param only_def ftHĝݎ擾
	 * @return true Rgʕ񂠂
	 */
	bool GetCommentList(UnicodeString fnam,
			TStringList *ln_lst, TStringList *bgn_lst, TStringList *end_lst,
			bool is_h2t = false, bool only_def = false);

	/**
	 * @brief Xg{bNX̎ws̃RgJnʒu擾
	 * @param fnam t@C
	 * @param lp Xg{bNX
	 * @param idx CfbNX
	 * @param en_mlt sRgɑΉ
	 * @return int RgJnʒu
	 */
	int GetCommentPos(UnicodeString fnam, TListBox *lp, int idx, bool en_mlt = true);

	/**
	 * @brief gqˑ̃ftHgop^[擾
	 * @param fext gq
	 * @return UnicodeString ftHgop^[
	 */
	UnicodeString GetDefHeadlnPtn(UnicodeString fext);

	/**
	 * @brief op^[擾
	 * 
	 * @param fnam t@C
	 * @param hl_lst gqΉoXg
	 * @param only_def ftHĝݎ擾
	 * @return UnicodeString op^[
	 */
	UnicodeString GetHeadlinePtn(UnicodeString fnam, TStringList *hl_lst = NULL, bool only_def = false);
};
//---------------------------------------------------------------------------
extern HighlightFile *UserHighlight;

//---------------------------------------------------------------------------
/**
 * @brief ftHg̗\p^[擾
 * @param fext gq
 * @param sns_case 召
 * @param is_xml ΏۂXML
 * @param is_log Ώۂ^XNO
 * @param is_h2t HTMLTEXTϊ[h
 * @return UnicodeString \p^[ 
 */
UnicodeString GetDefReservedPtn(UnicodeString fext, bool &sns_case, bool is_xml, bool is_log, bool is_h2t);

/**
 * @brief ftHg̐lp^[擾
 * @param fext gq
 * @return UnicodeString lp^[
 */
UnicodeString GetDefNumericPtn(UnicodeString fext);

/**
 * @brief ftHg̃V{擾
 * @param fext gq
 * @param is_xml ΏۂXML
 * @param is_h2t HTMLTEXTϊ[h
 * @return UnicodeString 
 */
UnicodeString GetDefSymbolChars(UnicodeString fext, bool is_xml, bool is_h2t);

/**
 * @brief ftHg̕p
 * @param fext gq
 * @param[o] use_esc GXP[vV[PXL
 * @param is_xml ΏۂXML
 * @param is_ini ΏۂINIt@C
 * @param is_h2t HTMLTEXTϊ[h
 * @return UnicodeString p
 */
UnicodeString GetDefQuotChars(UnicodeString fext, bool &use_esc, bool is_xml, bool is_ini, bool is_h2t);

/**
 * @brief ftHg̊֐p^[擾
 * @param fext gq
 * @param[out] name_ptn O擾p^[
 * @param is_h2t HTMLTEXTϊ[h
 * @return UnicodeString ֐p^[
 */
UnicodeString GetDefFunctionPtn(UnicodeString fext, UnicodeString &name_ptn, bool is_h2t);

/**
 * @brief SearchPair R}hpp^[擾
 * @param fext gq
 * @param[out] lst p^[̃Xg
 * @return true p^[
 */
bool GetSearchPairPtn(UnicodeString fext, TStringList *lst);

/**
 * @brief ftHg̍\\`擾
 * @param fext gq
 * @param[out] lst ʃXg
 * @param hl_lst gqΉoXg
 * @return true \\`
 */
bool GetDefaultHighlight(UnicodeString fext, TStringList *lst, TStringList *hl_lst = NULL);
//---------------------------------------------------------------------------
#endif
